unit DatabaseQuery;

interface

uses
  SysUtils,
  Classes,
  PDDirectLib_TLB,
  PDStandardLib_TLB,
  ComObj,
  Dialogs;

Const
  RecordDatabaseLimit=10;

var
  RecordDatabase: Array [1..RecordDatabaseLimit] of IPDDatabaseQuery;
  RecordAdapter: Array [1..RecordDatabaseLimit] of IPDRecordAdapter;
  RecordUsed: Array [1..RecordDatabaseLimit] of Boolean;

procedure DatabaseQuery_OpenRecordDatabase(SLI:TStringList; var SLO:TStringList); cdecl; export;

implementation

procedure DatabaseQuery_OpenRecordDatabase(SLI:TStringList; var SLO:TStringList); cdecl; export;
var
  bid:Integer;
  acc:EAccessModes;
begin
  try
    MessageDlg('Base : "'+SLI.Strings[2]+'" Mode : "'+SLI.Strings[3]+'" Adapteur : "'+SLI.Strings[4]+'"',
      mtWarning,[mbOk],0);

    bid:=1;
    while (bid<(RecordDatabaseLimit+1)) and RecordUsed[bid] do
      Inc(bid);

    if bid<(RecordDatabaseLimit+1) then
    begin
      if Pos('S',SLI.Strings[3])>0 then acc:=eShowSecret else acc:=0;
      if Pos('R',SLI.Strings[3])>0 then acc:=acc or eRead;
      if Pos('W',SLI.Strings[3])>0 then acc:=acc or eWrite;
      RecordDatabase[bid]:=CreateComObject(StringToGUID('PDDirect.PDDatabaseQuery')) as IPDDatabaseQuery;
      RecordAdapter[bid]:=RecordDatabase[bid].OpenRecordDatabase(SLI.Strings[2],SLI.Strings[4],acc) as IPDRecordAdapter;
      RecordUsed[bid]:=True;
      SLO.Add(IntToStr(bid));
    end
    else
      SLO.Add('0');

  except on E:Exception do
  end;
end;

end.
