//
// PalmSync par Jean-Marc QUR
// Tous droits rservs APIEND et Jean-Marc QUR, 2001
//

unit PDInOut;

interface

uses
  SysUtils,
  Classes,
  PDDirectLib_TLB,
  PDStandardLib_TLB,
  ComObj,
  Dialogs; 

procedure consigne(str:string);

function ReadByte(pUtility:IPDUtility; vData:Variant; ofs:Integer; var SLO:TStringList):Integer;
function ReadDate(pUtility:IPDUtility; vData:Variant; ofs:Integer; var SLO:TStringList):Integer;
function ReadLong(pUtility:IPDUtility; vData:Variant; ofs:Integer; var SLO:TStringList):Integer;
function ReadString(pUtility:IPDUtility; vData:Variant; ofs:Integer; var SLO:TStringList):Integer;
function ReadTime(pUtility:IPDUtility; vData:Variant; ofs:Integer; var SLO:TStringList):Integer;
function ReadWord(pUtility:IPDUtility; vData:Variant; ofs:Integer; var SLO:TStringList):Integer;

function WriteByte(pUtility:IPDUtility; var vData:OleVariant; ofs:Integer; sli:String):Integer;
function WriteDate(pUtility:IPDUtility; var vData:OleVariant; ofs:Integer; sli:String):Integer;
function WriteLong(pUtility:IPDUtility; var vData:OleVariant; ofs:Integer; sli:String):Integer;
function WriteString(pUtility:IPDUtility; var vData:OleVariant; ofs:Integer; sli:String):Integer;
function WriteTime(pUtility:IPDUtility; var vData:OleVariant; ofs:Integer; sli:String):Integer;
function WriteWord(pUtility:IPDUtility; var vData:OleVariant; ofs:Integer; sli:String):Integer;

implementation

procedure consigne(str:string);
var
  f:TextFile;
begin
  try
    if FileExists('C:\PALMSYNC.TXT') then
    begin
      AssignFile(f,'C:\PALMSYNC.TXT');
      Append(f);
      writeln(f,str);
      flush(f);
      closefile(f);
    end;
  except
    on E:Exception do ;
  end;
end;

function ReadByte(pUtility:IPDUtility; vData:Variant; ofs:Integer; var SLO:TStringList):Integer;
var
  DataL:LongInt;
begin
  if (ofs mod 2)=0 then
  begin
    pUtility.ByteArrayToDWORD(vData,ofs,True, DataL);
    SLO.Add(IntToStr( (DataL and $FF000000) shr 24));
  end
  else
  begin
    pUtility.ByteArrayToDWORD(vData,ofs-1,True, DataL);
    SLO.Add(IntToStr( (DataL and $00FF0000) shr 16));
  end;
  result:=ofs+1;
end;

function ReadDate(pUtility:IPDUtility; vData:Variant; ofs:Integer; var SLO:TStringList):Integer;
var
  DataL:LongInt;
  an,
  ms,
  jr:integer;
begin
  pUtility.ByteArrayToDWORD(vData,ofs,True, DataL);
  DataL:=(DataL and $FFFF0000) shr 16;
  if DataL=$FFFF then
  begin
    SLO.Add('');
  end
  else
  begin
    jr:=DataL and $1F;
    ms:=(DataL shr 5) and $F;
    an:=((DataL shr 9) and $7F)+1904;
    SLO.Add(Format('%2.2d/%2.2d/%4.4d',[jr,ms,an]));
  end;
  result:=ofs+2;
end;

function ReadLong(pUtility:IPDUtility; vData:Variant; ofs:Integer; var SLO:TStringList):Integer;
var
  DataL:LongInt;
begin
  pUtility.ByteArrayToDWORD(vData,ofs,True, DataL);
  SLO.Add(IntToStr(DataL));
  result:=ofs+4;
end;

function ReadString(pUtility:IPDUtility; vData:Variant; ofs:Integer; var SLO:TStringList):Integer;
var
  DataS:WideString;
begin
  // Length(vData) remplac par $FFFF (valeur limite arbitraire)
  // car Length retourne une valeur fausse !!
  ofs:=pUtility.ByteArrayToBSTR(vData,ofs,$FFFF,DataS);
  SLO.Add(DataS);
  result:=ofs;
end;

function ReadTime(pUtility:IPDUtility; vData:Variant; ofs:Integer; var SLO:TStringList):Integer;
var
  DataL:LongInt;
begin
  pUtility.ByteArrayToDWORD(vData,ofs,True, DataL);
  DataL:=(DataL and $FFFF0000) shr 16;
  if DataL=$FFFF then
  begin
    SLO.Add('');
  end
  else
    SLO.Add(Format('%2.2d:%2.2d', [DataL shr 8,DataL and $00FF]));
  result:=ofs+2;
end;

function ReadWord(pUtility:IPDUtility; vData:Variant; ofs:Integer; var SLO:TStringList):Integer;
var
  DataL:LongInt;
begin
  pUtility.ByteArrayToDWORD(vData,ofs,True, DataL);
  SLO.Add(IntToStr( (DataL and $FFFF0000) shr 16));
  result:=ofs+2;
end;

function WriteByte(pUtility:IPDUtility; var vData:OleVariant; ofs:Integer; sli:String):Integer;
var
  DataL,
  DataM:LongInt;
begin
  pUtility.ByteArrayToDWORD(vData,ofs,True, DataM);
  DataM:=DataM and $00FFFFFF;

  DataL:=StrToInt(sli) shl 24;
  pUtility.DWORDToByteArray(vData,ofs,True, DataL+DataM);
  result:=ofs+1;
end;

function WriteDate(pUtility:IPDUtility; var vData:OleVariant; ofs:Integer; sli:String):Integer;
var
  DataL,
  DataM:LongInt;

  jr,
  ms,
  an:word;
begin
  pUtility.ByteArrayToDWORD(vData,ofs,True, DataM);
  DataM:=DataM and $0000FFFF;

  if sli<>'' then
  begin
    DecodeDate(StrToDate(sli),an,ms,jr);
    DataL:=((an-1904) shl 9)+(ms shl 5)+jr;
    DataL:=DataL shl 16;
  end
  else
    DataL:=LongInt($FFFF0000);
  pUtility.DWORDToByteArray(vData,ofs,True, DataL+DataM);
  result:=ofs+2;
end;

function WriteLong(pUtility:IPDUtility; var vData:OleVariant; ofs:Integer; sli:String):Integer;
var
  DataL:LongInt;
begin
  DataL:=StrToInt(sli);
  pUtility.DWORDToByteArray(vData,ofs,True, DataL);
  result:=ofs+4;
end;

function WriteString(pUtility:IPDUtility; var vData:OleVariant; ofs:Integer; sli:String):Integer;
var
  DataS:WideString;
begin
  DataS:=sli;
  ofs:=pUtility.BSTRToByteArray(vData,ofs,DataS);
  result:=ofs;
end;

function WriteTime(pUtility:IPDUtility; var vData:OleVariant; ofs:Integer; sli:String):Integer;
var
  vhr,
  vmn:integer;
  DataL,
  DataM:LongInt;
begin
  pUtility.ByteArrayToDWORD(vData,ofs,True, DataM);
  DataM:=DataM and $0000FFFF;

  if sli<>'' then
  begin
    vhr:=StrToInt(Copy(sli,1,Pos(':',sli)-1));
    vmn:=StrToInt(Copy(sli,Pos(':',sli)+1,length(sli)-Pos(':',sli)));
    DataL:=((vhr shl 8)+vmn) shl 16;
  end
  else
    DataL:=LongInt($FFFF0000);
  pUtility.DWORDToByteArray(vData,ofs,True, DataL+DataM);
  result:=ofs+2;
end;

function WriteWord(pUtility:IPDUtility; var vData:OleVariant; ofs:Integer; sli:String):Integer;
var
  DataL,
  DataM:LongInt;
begin
  pUtility.ByteArrayToDWORD(vData,ofs,True, DataM);
  DataM:=DataM and $0000FFFF;
  DataL:=StrToInt(sli) shl 16;
  pUtility.DWORDToByteArray(vData,ofs,True, DataL+DataM);
  result:=ofs+2;
end;

end.
