//
// PalmSync par Jean-Marc QUR
// Tous droits rservs APIEND et Jean-Marc QUR, 2001
//

unit RecordDatabase;

interface

uses
  SysUtils,
  Classes,
  PDDirectLib_TLB,
  PDStandardLib_TLB,
  ComObj,
  Dialogs,
  PDInOut;

Const
  Limit=10;

var
  Database: Array [1..Limit] of IPDDatabaseQuery;
  Adapter: Array [1..Limit] of IPDRecordAdapter;
  Used: Array [1..Limit] of Boolean;

procedure RecordDatabase_OpenDatabase(SLI:TStringList; var SLO:TStringList);
procedure RecordDatabase_ReadNext(SLI:TStringList; var SLO:TStringList);
procedure RecordDatabase_CloseDatabase(SLI:TStringList; var SLO:TStringList);
procedure RecordDatabase_WriteRecord(SLI:TStringList; var SLO:TStringList);
procedure RecordDatabase_Remove(SLI:TStringList; var SLO:TStringList);
procedure RecordDatabase_ReadById(SLI:TStringList; var SLO:TStringList);
procedure RecordDatabase_ReadNextModified(SLI:TStringList; var SLO:TStringList);

implementation

procedure RecordDatabase_OpenDatabase(SLI:TStringList; var SLO:TStringList);
var
  bid:Integer;
  acc:EAccessModes;
begin
//  MessageDlg('Base : "'+SLI.Strings[2]+'" Mode : "'+SLI.Strings[3]+'" Adapteur : "'+SLI.Strings[4]+'"',
//      mtWarning,[mbOk],0);

  try
    bid:=1;
    while (bid<(Limit+1)) and Used[bid] do
      Inc(bid);

    if bid<(Limit+1) then
    begin
      if Pos('S',SLI.Strings[3])>0 then acc:=eShowSecret else acc:=0;
      if Pos('R',SLI.Strings[3])>0 then acc:=acc or eRead;
      if Pos('W',SLI.Strings[3])>0 then acc:=acc or eWrite;
      Database[bid]:=CreateComObject(StringToGUID('PDDirect.PDDatabaseQuery')) as IPDDatabaseQuery;
      Adapter[bid]:=Database[bid].OpenRecordDatabase(SLI.Strings[2],SLI.Strings[4],acc) as IPDRecordAdapter;
      Adapter[bid].IterationIndex:=0; // Premier Enregistrement
      Used[bid]:=True;
      SLO.Add(IntToStr(bid));
    end
    else
      SLO.Add('0');

  except on E:Exception do
//MessageDlg(E.Message,mtWarning,[mbOK],0);
  end;
end;

procedure RecordDatabase_ReadNext(SLI:TStringList; var SLO:TStringList);
var
  pUtility:IPDUtility;
  vData:Variant;
  vUniqueID:OleVariant;
  nIndex:Integer;
  nCategory:Integer;
  eAttributes:ERecordAttributes;

  bid,
  occ,
  ofs,
  ind:Integer;
  sax:TStringList;
  str:String;

  DataL:LongInt;
  sAttr:String;
begin
  sax:=TStringList.Create();
  try
    bid:=StrToInt(SLI.Strings[2]);
    pUtility:=CreateComObject(StringToGUID('PDDirect.PDUtility')) as IPDUtility;

    if SLI.Strings[1]='ReadById' then
    begin
      vUniqueId:=StrToInt(SLI.Strings[4]);
      vData:=Adapter[bid].ReadById(nIndex,vUniqueId,nCategory,eAttributes);
    end
    else
      if SLI.Strings[1]='ReadNextModified' then
        vData:=Adapter[bid].ReadNextModified(nIndex,vUniqueId,nCategory,eAttributes)
      else // 'ReadNext'
        vData:=Adapter[bid].ReadNext(nIndex,vUniqueId,nCategory,eAttributes);

    if Adapter[bid].EOF then sAttr:='E' else sAttr:=' ';
    if (eAttributes and $00000080)>0 then sAttr:=sAttr+'D';
    if (eAttributes and $00000040)>0 then sAttr:=sAttr+'M';
    if (eAttributes and $00000010)>0 then sAttr:=sAttr+'S';
    if (eAttributes and $00000008)>0 then sAttr:=sAttr+'A';
    if Pos('E',sAttr)>0 then // EOF
    begin
      SLO.Add('0');
      SLO.Add('');
      SLO.Add('0');
      SLO.Add(sAttr);
      SLO.Add('');
    end
    else
    begin
      SLO.Add(IntToStr(nIndex));
      SLO.Add(String(vUniqueID));
      SLO.Add(IntToStr(nCategory));
      SLO.Add(sAttr);

      // Dcodage par rapport au MetaData
      ofs:=0;
      for occ:=1 to length(SLI.Strings[3]) do
        case SLI.Strings[3][occ] of

          // Types usuels
          'B' : ofs:=ReadByte(pUtility,vData,ofs,SLO);
          'D' : ofs:=ReadDate(pUtility,vData,ofs,SLO);
          'L' : ofs:=ReadLong(pUtility,vData,ofs,SLO);
          'S' : ofs:=ReadString(pUtility,vData,ofs,SLO);
          'T' : ofs:=ReadTime(pUtility,vData,ofs,SLO);
          'W' : ofs:=ReadWord(pUtility,vData,ofs,SLO);

          // Structures compresses
          'a' : begin
                  pUtility.ByteArrayToDWORD(vData,ofs,True,DataL);
                  ofs:=ofs+4;
                  // Type de tlphone
                  for ind:=0 to 4 do
                    SLO.Add(IntToStr((DataL and ($0000000F shl (4*ind)) shr (4*ind))));
                  // Initialise les champs : valeur renseignes ou ''
                  pUtility.ByteArrayToDWORD(vData,ofs,True,DataL);
                  ofs:=9;
                  for ind:=0 to 18 do
                  begin
                    if (DataL and ($00000001 shl ind))<>0 then
                      ofs:=ReadString(pUtility,vData,ofs,SLO)
                    else
                      SLO.Add('');
                  end;
                end;
          'b' : begin
                  // Heure Dbut, Fin et Date
                  ofs:=ReadTime(pUtility,vData,ofs,SLO);
                  ofs:=ReadTime(pUtility,vData,ofs,SLO);
                  ofs:=ReadDate(pUtility,vData,ofs,SLO);

//pUtility.ByteArrayToDWORD(vData,7,True,DataL);
//DataL:=(DataL and $FF000000) shr 24;
//MessageDlg('Filler->'+IntToStr(DataL),mtWarning,[mbOk],0);
//ofs:=6;

                  // Initialise les champs : valeur renseignes ou ''
                  try pUtility.ByteArrayToDWORD(vData,ofs,True,DataL);
                  except on E:Exception do DataL:=0;
                  end;

                  DataL:=(DataL and $FF000000) shr 24;
                  ofs:=8;

                  // Alarme dlai et unit
                  if (DataL and $40)<>0 then
                  begin
                    ofs:=ReadByte(pUtility,vData,ofs,SLO);
                    ofs:=ReadByte(pUtility,vData,ofs,SLO);
                  end
                  else
                  begin
                    SLO.Add('');
                    SLO.Add('');
                  end;

                  // Type de rptition, Mode de rptition, date de fin,
                  //  frquence, journe, semaine de dpart
                  if (DataL and $20)<>0 then
                  begin
                    ofs:=ReadByte(pUtility,vData,ofs,SLO);
                    ofs:=ReadByte(pUtility,vData,ofs,SLO);
                    ofs:=ReadDate(pUtility,vData,ofs,SLO);
                    ofs:=ReadByte(pUtility,vData,ofs,SLO);
                    ofs:=ReadByte(pUtility,vData,ofs,SLO);
                    ofs:=ReadByte(pUtility,vData,ofs,SLO);
                    ofs:=ofs+1;
                  end
                  else
                  begin
                    SLO.Add('');
                    SLO.Add('');
                    SLO.Add('');
                    SLO.Add('');
                    SLO.Add('');
                    SLO.Add('');
                  end;

                  // Liste des exceptions
                  if (DataL and $8)<>0 then
                  begin
                    ofs:=ReadWord(pUtility,vData,ofs,SLO);
                    for ind:=1 to StrToInt(SLO.Strings[SLO.Count-1]) do
                      ofs:=ReadDate(pUtility,vData,ofs,sax);
                    str:='';
                    for ind:=1 to sax.Count-1 do
                      str:=str+sax.Strings[ind]+',';
                    str:=Copy(str,1,Length(str)-1);
                    SLO.Add(str);
                  end
                  else
                  begin
                    SLO.Add('');
                    SLO.Add('');
                  end;

                  // Description
                  if (DataL and $4)<>0 then
                    ofs:=ReadString(pUtility,vData,ofs,SLO)
                  else
                    SLO.Add('');

                  // Notes
                  if (DataL and $10)<>0 then
                    ofs:=ReadString(pUtility,vData,ofs,SLO)
                  else
                    SLO.Add('');
                end;

          '-' : exit;
        end;

    end;
  except on E:Exception do
    consigne(E.Message);
  end;
  sax.Free;
end;

procedure RecordDatabase_CloseDatabase(SLI:TStringList; var SLO:TStringList);
var
  bid:Integer;
begin
  try
    bid:=StrToInt(SLI.Strings[2]);
    Database[bid]:=nil; // autre mthode de libration ?
    Adapter[bid]:=nil;
    Used[bid]:=False;
  except on E:Exception do
//MessageDlg(E.Message,mtWarning,[mbOK],0);
  end;
end;

procedure RecordDatabase_WriteRecord(SLI:TStringList; var SLO:TStringList);
var
  pUtility:IPDUtility;
  vData,
  xData:OleVariant;
  vUniqueID:OleVariant;
  nCategory:Integer;
  eAttributes:ERecordAttributes;

  bid,
  ind,
  occ,
  ofs:integer;
  sax:TStringList;
  str:String;

  DataL:LongInt;
begin
  sax:=TStringList.Create();
  try
    bid:=StrToInt(SLI.Strings[2]);
    pUtility:=CreateComObject(StringToGUID('PDDirect.PDUtility')) as IPDUtility;

    if SLI.Strings[4]<>'' then
      vUniqueID:=StrToInt(SLI.Strings[4])
    else
      VarCast(vUniqueID,'',varEmpty);

    nCategory:=StrToInt(SLI.Strings[5]);
    if Pos('D',SLI.Strings[6])>0 then eAttributes:=$00000080 else eAttributes:=$00000000;
    if Pos('M',SLI.Strings[6])>0 then eAttributes:=eAttributes+$00000040;
    if Pos('S',SLI.Strings[6])>0 then eAttributes:=eAttributes+$00000010;
    if Pos('A',SLI.Strings[6])>0 then eAttributes:=eAttributes+$00000008;

    // Encodage par rapport au MetaData
    ofs:=0;
    vData:=VarArrayCreate([0, 10240], varByte);
    for occ:=1 to length(SLI.Strings[3]) do
      case SLI.Strings[3][occ] of
        // Types usuels
        'B' : ofs:=WriteByte(pUtility,vData,ofs,SLI.Strings[occ+6]);
        'D' : ofs:=WriteDate(pUtility,vData,ofs,SLI.Strings[occ+6]);
        'L' : ofs:=WriteLong(pUtility,vData,ofs,SLI.Strings[occ+6]);
        'S' : ofs:=WriteString(pUtility,vData,ofs,SLI.Strings[occ+6]);
        'T' : ofs:=WriteTime(pUtility,vData,ofs,SLI.Strings[occ+6]);
        'W' : ofs:=WriteWord(pUtility,vData,ofs,SLI.Strings[occ+6]);

        // Structure compresses
        'a' : begin
                DataL:=0;
                // Type de tlphone
                for ind:=0 to 4 do
                  if SLI.Strings[7+ind]='' then SLI.Strings[7+ind]:=IntToStr(ind);
                for ind:=0 to 4 do
                  DataL:=DataL + (StrToInt(SLI.Strings[7+ind]) shl (4*ind));
                ofs:=WriteLong(pUtility,vData,ofs,IntToStr(DataL));
                DataL:=$00000000;
                for ind:=0 to 18 do
                  if SLI.Strings[12+ind]<>'' then
                    DataL:=DataL+($00000001 shl ind);
                ofs:=WriteLong(pUtility,vData,ofs,IntToStr(DataL));
                // Initialise les champs
                pUtility.ByteArrayToDWORD(vData,ofs,True,DataL);
                ofs:=9;
                for ind:=0 to 18 do
                  if SLI.Strings[12+ind]<>'' then
                    ofs:=WriteString(pUtility,vData,ofs,SLI.Strings[12+ind]);
              end;
        'b' : begin
                // Heure Dbut, Fin et Date
                ofs:=WriteTime(pUtility,vData,ofs,SLI.Strings[7]);
                ofs:=WriteTime(pUtility,vData,ofs,SLI.Strings[8]);
                ofs:=WriteDate(pUtility,vData,ofs,SLI.Strings[9]);

                // Initialise les champs : valeur renseignes ou ''
                if (SLI.Strings[10]<>'') or (SLI.Strings[11]<>'') then DataL:=$40 else DataL:=$00;    // 40 00
                if (SLI.Strings[12]<>'') or (SLI.Strings[13]<>'') or
                   (SLI.Strings[14]<>'') or (SLI.Strings[15]<>'') or
                   (SLI.Strings[16]<>'') or (SLI.Strings[17]<>'') then DataL:=DataL+$20;
                if (SLI.Strings[18]<>'') or (SLI.Strings[19]<>'') then DataL:=DataL+$08;
                if (SLI.Strings[20]<>'') then DataL:=DataL+$04;
                if (SLI.Strings[21]<>'') then DataL:=DataL+$10;
                ofs:=WriteByte(pUtility,vData,ofs,IntToStr(DataL));
                Inc(ofs);

                // Alarme dlai et unit
                if (SLI.Strings[10]<>'') or (SLI.Strings[11]<>'') then
                begin
                  ofs:=WriteByte(pUtility,vData,ofs,SLI.Strings[10]);
                  ofs:=WriteByte(pUtility,vData,ofs,SLI.Strings[11]);
                end;

                // Type de rptition, date de fin, frquence, journe,
                // semaine de dpart
                if (SLI.Strings[12]<>'') or (SLI.Strings[13]<>'') or
                   (SLI.Strings[14]<>'') or (SLI.Strings[15]<>'') or
                   (SLI.Strings[16]<>'') or (SLI.Strings[17]<>'') then
                begin
                  ofs:=WriteByte(pUtility,vData,ofs,SLI.Strings[12]);
                  ofs:=WriteByte(pUtility,vData,ofs,SLI.Strings[13]);
                  ofs:=WriteDate(pUtility,vData,ofs,SLI.Strings[14]);
                  ofs:=WriteByte(pUtility,vData,ofs,SLI.Strings[15]);
                  ofs:=WriteByte(pUtility,vData,ofs,SLI.Strings[16]);
                  ofs:=WriteByte(pUtility,vData,ofs,SLI.Strings[17]);
                  ofs:=ofs+1;
                end;
                // Liste des exceptions
                if (SLI.Strings[18]<>'') or (SLI.Strings[19]<>'') then
                begin
                  str:=SLI.Strings[19];
                  ind:=Pos(',',str);
                  while ind>0 do
                  begin
                    sax.Add(Copy(str,1,ind));
                    str:=Copy(str,ind+1,Length(str)-ind);
                  end;
                  sax.Add(str);
                  ofs:=WriteWord(pUtility,vData,ofs,IntToStr(sax.Count));
                  for ind:=0 to sax.Count-1 do
                  begin
                    ofs:=WriteDate(pUtility,vData,ofs,sax.Strings[ind]);
                  end;
                end;
                // Description
                if (SLI.Strings[20]<>'') then
                  ofs:=WriteString(pUtility,vData,ofs,SLI.Strings[20]);
               // Notes
                if (SLI.Strings[21]<>'') then
                 ofs:=WriteString(pUtility,vData,ofs,SLI.Strings[21]);
              end;
        '-' : begin
              end;
      end;

      xData:=VarArrayCreate([0, ofs-1], varByte);
      for occ:=0 to ofs-1 do
        xData[occ]:=vData[occ];
    Adapter[bid].Write(vUniqueId,nCategory,eAttributes,xData);
    SLO.Add(String(vUniqueId));
  except on E:Exception do
//MessageDlg(E.Message,mtWarning,[mbOK],0);
  end;
  sax.Free;
end;

procedure RecordDatabase_Remove(SLI:TStringList; var SLO:TStringList);
var
  vUniqueID:OleVariant;
  bid:Integer;
begin
  try
    bid:=StrToInt(SLI.Strings[2]);
    vUniqueId:=StrToInt(SLI.Strings[3]);
    Adapter[bid].Remove(vUniqueId);
    SLO.Add('OK');
  except on E:Exception do
//MessageDlg(E.Message,mtWarning,[mbOK],0);
  end;
end;

procedure RecordDatabase_ReadById(SLI:TStringList; var SLO:TStringList);
begin
  RecordDatabase_ReadNext(SLI,SLO);
end;

procedure RecordDatabase_ReadNextModified(SLI:TStringList; var SLO:TStringList);
begin
  RecordDatabase_ReadNext(SLI,SLO);
end;

end.
