//
// PalmSync par Jean-Marc QUR
// Tous droits rservs APIEND et Jean-Marc QUR, 2001
//

unit WDInOut;

interface

uses Classes,SysUtils,Dialogs;
procedure WDAZtoStringList(WDAZ:PChar; var SL:TStringList);
function SLtoEscString(SL:TStringList):String;

implementation

// HexStoChar( <chane hexa> ) -> caractre ascii associ
// ex. HexStoChar('20') -> espace
function HexStoChar(Str:String):Char;
var
  res:Char;
begin
  try
    res:=Chr(StrToInt('$'+Str));
  except on E:Exception do res:='?';
  end;
  result:=res;
end;

// EscStoString( <chane avec code d'chap.> ) -> chane ascii
// ex. EscStoString('A%%B%20C') -> 'A%B C'
// -1er % doubl annule chap. -> '%'
// -2nd % suivi de la valeur hexa du caractre -> espace ($20)
function EscStoString(Str:String):String;
var
  occ:Integer;
  exp,
  res:String;
begin
  res:='';
  occ:=Pos('%',Str);
  while occ>0 do
  begin
    exp:=Copy(Str,occ+1,2);
    if exp[1]<>'%' then
    begin
      res:=res+Copy(Str,1,occ-1)+HexStoChar(exp);
      Str:=Copy(Str,occ+3,Length(Str)-occ-2);
    end
    else
    begin
      res:=res+Copy(Str,1,occ);
      Str:=Copy(Str,occ+2,Length(Str)-occ-1);
    end;
    occ:=Pos('%',str);
  end;
  res:=res+Str;
  result:=res;
end;

// WDAZtoStringList( <chane  zro terminal tabulle> ) -> liste de chanes
// ex. WDAZtoStringList('A%%B%20C'#9'DEF') -> SL[1]='A%B C' et SL[2]='DEF'
procedure WDAZtoStringList(WDAZ:PChar; var SL:TStringList);
var
  occ:Integer;
  str:String;
begin
  str:=String(WDAZ);
  occ:=Pos(#9,str);
  while occ>0 do
  begin
    SL.Add(EscStoString(Copy(str,1,occ-1)));
    str:=Copy(str,occ+1,Length(str)-occ);
    occ:=Pos(#9,str);
  end;
  SL.Add(EscSToString(str));
end;

// StoEscString( <chane ascii> ) -> chane avec code d'chap.
// ex. StoEscString('A%B'#10'C') -> 'A%%B%10C'
// - '%' doubl
// - #10 converti en '%' valeur hexa du caractre
function StoEscString(Str:String):String;
var
  occ,
  exp:Integer;
  res:String;
begin
  res:='';
  for occ:=1 to Length(Str) do
  begin
    exp:=Ord(Str[occ]);
    if (exp=37) then
      res:=res+'%%'
    else if (exp<32) or (exp>127) then
      res:=res+'%'+Format('%.2x',[exp])
    else
      res:=res+Str[occ];
  end;
  result:=res;
end;

// SLtoEscString( <liste de chane> ) -> chane  zro terminal tabulle
// ex. SLtoEscString( SL ) -> 'A%%BC' #9 'D%10EF'
// avec SL.Strings[0]='A%BC' et SL.Strings[1]='D'#10'EF'
function SLtoEscString(SL:TStringList):String;
var
  occ:Integer;
  res:string;
begin
  res:='';
  if SL.Count>0 then
  begin
    for occ:=0 to SL.Count-1 do
      res:=res+StoEscString(SL.Strings[occ])+#9;
    res:=Copy(res,1,Length(res)-1);
  end;
  result:=res;
end;

end.
